(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-router'), require('prop-types'), require('http')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react', 'react-router', 'prop-types', 'http'], factory) :
	(factory((global.ReactRouterApi = {}),global.React,global.ReactRouter,global.PropTypes,global.http));
}(this, (function (exports,React,reactRouter,PropTypes,http) { 'use strict';

var React__default = 'default' in React ? React['default'] : React;
PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
http = http && http.hasOwnProperty('default') ? http['default'] : http;

var CREATE_CONNECTION = '@@listener/CREATE_CONNECTION';
var createListener = function createListener() {
	return http.createServer(function (req, res) {
		res.writeHead(200, { 'Content-Type': 'application/json' });
		res.end();
	}).listen('4545', 'localhost');
};

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListenerRouter = function (_Component) {
  _inherits(ListenerRouter, _Component);

  function ListenerRouter() {
    _classCallCheck(this, ListenerRouter);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  ListenerRouter.prototype.componentWillMount = function componentWillMount() {
    var _props = this.props,
        propsStore = _props.store,
        history = _props.history;

    this.store = propsStore || this.context.store;
    this.store.dispatch({ type: CREATE_CONNECTION });
  };

  ListenerRouter.prototype.render = function render() {
    return React__default.createElement('div', null);
  };

  return ListenerRouter;
}(React.Component);

ListenerRouter.propTypes = {
  store: PropTypes.object,
  children: PropTypes.node
};
ListenerRouter.contextTypes = {
  store: PropTypes.object
};

function listener() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
	    type = _ref.type,
	    payload = _ref.payload;

	if (type === CREATE_CONNECTION) return Object.assign({}, state, { c: createListener() });
	return state;
}

function listenerMiddleware() {
  return function () {
    return function (next) {
      return function (action) {
        next(action);
      };
    };
  };
}

exports.ListenerRouter = ListenerRouter;
exports.listenerMiddleware = listenerMiddleware;
exports.createListener = createListener;
exports.CREATE_CONNECTION = CREATE_CONNECTION;
exports.listener = listener;

Object.defineProperty(exports, '__esModule', { value: true });

})));
